-- This file: (find-LATEXfile "2018tug-dednat6.lua")
--       See: (find-LATEXfile "2018tug-dednat6.tex")
-- (defun e () (interactive) (find-fline "~/LATEX/2018tug-dednat6.tex"))
-- (defun l () (interactive) (find-fline "~/LATEX/2018tug-dednat6.lua"))
--


verbapat = "[\n #$%%&\\^_{}~]"
verbadict = {["\n"]="\\\\\n"}
verbaset_b  = function (c) verbadict[c] = "\\"..c end
verbaset_c  = function (c) verbadict[c] = "\\char"..string.byte(c).." " end
verbaexpand = function (str) return (string.gsub(str, verbapat, verbadict)) end
gchars      = function (str) return string.gmatch(str, ".") end
for c in gchars(" \\%&^_{}~") do verbaset_c(c) end
for c in gchars("#$")         do verbaset_b(c) end

verbalast = {}       -- contents of the last verbatim block
verbact = function (str)
    local doe   = function (A) return map(verbaexpand, A) end
    local doh1  = function (s) return format("\\verbahbox{%s}", s) end
    local doh   = function (A) return map(doh1, A) end
    local doc   = function (A) return table.concat(A, "%\n") end
    local dov   = function (s) return format("\\vbox{%%\n%s%%\n}", s) end
    local dobg  = function (s) return format("\\bgbox{%s}", s) end
    local dodef = function (s, action)
        local name = action:match":(.*)"
        return format("\\def\\%s{%s}", name, s)
      end
    --
    for _,action in ipairs(split(str)) do
      if     action == "e" then verbalast = doe(verbalast)
      elseif action == "h" then verbalast = doh(verbalast)
      elseif action == "c" then verbalast = doc(verbalast)
      elseif action == "v" then verbalast = dov(verbalast)
      elseif action == "bg" then verbalast = dobg(verbalast)
      elseif action:match"^def:" then verbalast = dodef(verbalast, action)
      elseif action == "o" then output(verbalast)
      elseif action == "P" then PP(verbalast)
      else   error("Unrecognized action: "..action)
      end
    end
  end

verbdef = function (name) verbact("e h c v bg def:"..name.." o") end


-- (find-dn6file "heads6.lua" "= tf:getblock()")
-- (find-dn6file "texfile.lua" "getblock =")
registerhead "%V" {
  name   = "myverbatim",
  action = function ()
      local i,j,origlines = tf:getblock()
      verbalast = origlines
      PPV(origlines)
    end,
}



--[[
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
registerhead = function () return function () end end
dofile "2018tug-dednat6.lua"
output = print

str = "Hello #$%&\\^_{}~!!!\n  Hey  hey"
print(verbaexpand(str))

verbalast = {"a", "bb", "ccc"}
verbact("P")

verbalast = {"a", "bb", "ccc"}
verbact("e h c P")
verbalast = {"a", "b b", "ccc"}
verbact("e h c v def:foo o")


--]]
